Doomsday Engine - Feature #1361

Rotation of objects away from walls during map load
2004-08-31 16:53 - danij

Status: Progressed Start date: 2004-08-31
Priority: Normal % Done: 20%
Assignee:

Category: Enhancement

Target version: Modding

Description

Now that we have 3D models representing the game
objects it often occurs where the models are facing the
wrong way, facing into a wall.

What I'm suggesting is:

It would be nice if during map loading Doomsday would
check to see if a THING's angle has been changed from
the default 0. If not it would then do a quick eight
direction check to see if there is a wall within X
distance. If there is a wall it then modifiys the angle of
the THING away from the nearest wall.

Obviously the above should not be used for monsters,
player starts and teleport exits.

Related to BUG 8185167?

Labels: Game Objects

History

#1 - 2007-05-20 01:02 - skyjake
Logged In: YES
user_id=717323

| seem to recall seeing some regular THINGs with a non-zero
angle. (Maybe only in Heretic and Hexen...) Those would not
be affected by your algorithm.

There is a real problem with the thing angles, though. The
game DLLs already do some thing-specific angle modifications
(like Heretic door statues), but it's not trivial to come up with a
rule that would work in all cases.

#2 - 2007-05-20 01:02 - flamepanther

Logged In: YES
user_id=1437996
Originator: NO

Has this become any more feasible since 20047 I'd like to see such a feature as well.

#3 - 2007-05-20 01:09 - flamepanther

Logged In: YES
user_id=1437996
Originator: NO

Has this become any more feasible since 2004? I'd like to see such a feature as well.
#4 - 2007-05-22 17:56 - flamepanther

Logged In: YES
user_id=1437996
Originator: NO

Apologies for the double-post. | hit the Refresh button at an inopportune time. :(

#5 - 2009-05-05 10:12 - skyjake

Logged In: YES
user_id=717323
Originator: NO

What if we just turned all mobjs away from walls, if they are within a certain N*radius distance of a wall? Of course those special mobjs you mention
would have to be skipped (player starts, etc.), but it might work just fine for 95% of the cases. It would also take care of the wall torches that currently
are handled as a special case (might even reuse the same logic).

There could be a rule to select the longest wall that is within range, and take the direction from there.

#6 - 2013-10-21 17:15 - skyjake

- Tags set to 3SDModel

- Subject changed from Rotation of Map objects away from walls during map load to Rotation of objects away from walls during map load
- Category set to Enhancement

- Status changed from New to In Progress

- % Done changed from 0 to 50

#7 - 2013-10-21 17:16 - skyjake
- % Done changed from 50 to 20

The "done" portion refers to the existing logic for doing this sort of tuning of objects (statues, torches).

#8 - 2016-07-05 23:54 - skyjake

- Status changed from In Progress to Progressed

#9 - 2019-11-29 16:34 - skyjake

- Target version set to Modding
